/*************************************************************************/
/* File:        seg7display8.v
 * Author:      Carl Ebeling
 *
 * Description: Count frames and display as a 4-digit decimal number
 *
 * Revsions:
 **************************************************************************/
`timescale 1ns/1ns

module frame_counter (
  input reset,
  input clk,
  input increment,       // Asserted when a new frame is started
  output [6:0] SEG0,
  output [6:0] SEG1,
  output [6:0] SEG2,
  output [6:0] SEG3
);

  wire [3:0] digit0, digit1, digit2, digit3;
  wire carry0, carry1, carry2;

  count10 c0 (.clk(clk), .reset(reset), .increment(increment), 
			  .count(digit0), .carry(carry0));
  count10 c1 (.clk(clk), .reset(reset), .increment(carry0), 
			  .count(digit1), .carry(carry1));
  count10 c2 (.clk(clk), .reset(reset), .increment(carry1), 
			  .count(digit2), .carry(carry2));
  count10 c3 (.clk(clk), .reset(reset), .increment(carry2),
			  .count(digit3), .carry());
  dec7seg d0 (.in(digit0), .segmentL(SEG0));
  dec7seg d1 (.in(digit1), .segmentL(SEG1));
  dec7seg d2 (.in(digit2), .segmentL(SEG2));
  dec7seg d3 (.in(digit3), .segmentL(SEG3));

endmodule
