/*************************************************************************/
/* File:        hw2_tf.v
 * Author:      Carl Ebeling
*
 * Description: Test fixture for HW2/Lab3 pre-design
 *              Tests the frame counter/7 segment display
 * Revsions:
 *   1.0        Initial design - 1/8/2009 - Carl Ebeling
 **************************************************************************/
`timescale 1ns/1ns

module hw2_tf();
   wire clk;
   wire reset;
   wire [6:0] SEG0, SEG1, SEG2, SEG3;
   reg 		  increment;
   integer		  counter;
   
   clockGen clock
	 (.clk					(clk),
	  .reset				(reset));
   reg [7:0]  s0, s1, s2, s3, s0r, s1r, s2r, s3r;
   
   initial increment=0;
   initial counter=0;
   always @(posedge clk) begin
	  if (reset) begin
		 increment <= 0;
	  end else begin
		 increment <= ($random & 'h100) == 0;
		 $display("counter = %d", counter);
		 s0 = " ";s1 = " ";s2 = " ";s3 = " ";
		 if (~SEG0[0]) s0 = "-";
		 if (~SEG1[0]) s1 = "-";
		 if (~SEG2[0]) s2 = "-";
		 if (~SEG3[0]) s3 = "-";
		 $display(" %s%s%s     %s%s%s     %s%s%s     %s%s%s   ", s3,s3,s3,s2,s2,s2,s1,s1,s1,s0,s0,s0);
		 s0 = " ";s1 = " ";s2 = " ";s3 = " ";
		 if (~SEG0[5]) s0 = "|";
		 if (~SEG1[5]) s1 = "|";
		 if (~SEG2[5]) s2 = "|";
		 if (~SEG3[5]) s3 = "|";
		 s0r = " ";s1r = " ";s2r = " ";s3r = " ";
		 if (~SEG0[1]) s0r = "|";
		 if (~SEG1[1]) s1r = "|";
		 if (~SEG2[1]) s2r = "|";
		 if (~SEG3[1]) s3r = "|";
		 $display("%s   %s   %s   %s   %s   %s   %s   %s", s3,s3r,s2,s2r,s1,s1r,s0,s0r);
		 s0 = " ";s1 = " ";s2 = " ";s3 = " ";
		 if (~SEG0[6]) s0 = "-";
		 if (~SEG1[6]) s1 = "-";
		 if (~SEG2[6]) s2 = "-";
		 if (~SEG3[6]) s3 = "-";
		 $display(" %s%s%s     %s%s%s     %s%s%s     %s%s%s   ", s3,s3,s3,s2,s2,s2,s1,s1,s1,s0,s0,s0);
		 s0 = " ";s1 = " ";s2 = " ";s3 = " ";
		 if (~SEG0[4]) s0 = "|";
		 if (~SEG1[4]) s1 = "|";
		 if (~SEG2[4]) s2 = "|";
		 if (~SEG3[4]) s3 = "|";
		 s0r = " ";s1r = " ";s2r = " ";s3r = " ";
		 if (~SEG0[2]) s0r = "|";
		 if (~SEG1[2]) s1r = "|";
		 if (~SEG2[2]) s2r = "|";
		 if (~SEG3[2]) s3r = "|";
		 $display("%s   %s   %s   %s   %s   %s   %s   %s", s3,s3r,s2,s2r,s1,s1r,s0,s0r);
		 s0 = " ";s1 = " ";s2 = " ";s3 = " ";
		 if (~SEG0[3]) s0 = "-";
		 if (~SEG1[3]) s1 = "-";
		 if (~SEG2[3]) s2 = "-";
		 if (~SEG3[3]) s3 = "-";
		 $display(" %s%s%s     %s%s%s     %s%s%s     %s%s%s   ", s3,s3,s3,s2,s2,s2,s1,s1,s1,s0,s0,s0);
		 $display("increment= %d", increment);
		 if (increment) counter <= counter + 1;
	  end
   end

   frame_counter fc
	 (.reset (reset),
	  .clk (clk),
	  .increment (increment),
	  .SEG0  (SEG0),
	  .SEG1  (SEG1),
	  .SEG2  (SEG2),
	  .SEG3  (SEG3)
	  );
   
endmodule 
